commit:     034be77f8fd376a0d7f3782694c1a94dd61b31e7
Author:     Andreas Sturmlechner <asturm <AT> gentoo <DOT> org>
AuthorDate: Sun Jan  1 16:00:32 2017 +0000
Commit:     Andreas Sturmlechner <asturm <AT> gentoo <DOT> org>
CommitDate: Sun Jan  1 16:08:13 2017 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=034be77f

kde-apps/konqueror: Fix runtime crash

Gentoo-bug: 604310
See also: https://bugs.kde.org/show_bug.cgi?id=373781

Package-Manager: portage-2.3.0

 .../files/konqueror-16.12.0-crashfix.patch         |  29 ++++++
 kde-apps/konqueror/konqueror-16.12.0-r1.ebuild     | 109 +++++++++++++++++++++
 2 files changed, 138 insertions(+)

diff --git a/kde-apps/konqueror/files/konqueror-16.12.0-crashfix.patch 
b/kde-apps/konqueror/files/konqueror-16.12.0-crashfix.patch
new file mode 100644
index 00000000..dd4fc75
--- /dev/null
+++ b/kde-apps/konqueror/files/konqueror-16.12.0-crashfix.patch
@@ -0,0 +1,29 @@
+From 4c6575a9852e3dfcf85bd849fa953dcc083029d9 Mon Sep 17 00:00:00 2001
+From: David Faure <[email protected]>
+Date: Wed, 21 Dec 2016 08:51:10 +0100
+Subject: Set Qt::AA_ShareOpenGLContexts like what Qt tells me to do:
+
+"initialize: Qt WebEngine seems to be initialized from a plugin. Please set 
Qt::AA_ShareOpenGLContexts using QCoreApplication::setAttribute before 
+constructing QGuiApplication."
+---
+ src/konqmain.cpp | 3 ++-
+ 1 file changed, 2 insertions(+), 1 deletion(-)
+
+diff --git a/src/konqmain.cpp b/src/konqmain.cpp
+index 774225e..73c6a2f 100644
+--- a/src/konqmain.cpp
++++ b/src/konqmain.cpp
+@@ -58,7 +58,8 @@ static KonqPreloadingHandler s_preloadingHandler;
+ 
+ extern "C" Q_DECL_EXPORT int kdemain(int argc, char **argv)
+ {
+-    KonquerorApplication app(argc, argv);    
++    QCoreApplication::setAttribute(Qt::AA_ShareOpenGLContexts); // says 
QtWebEngine
++    KonquerorApplication app(argc, argv);
+     KLocalizedString::setApplicationDomain("konqueror");
+ 
+     KAboutData aboutData("konqueror", i18n("Konqueror"), KONQUEROR_VERSION);
+-- 
+cgit v0.11.2
+
+

diff --git a/kde-apps/konqueror/konqueror-16.12.0-r1.ebuild 
b/kde-apps/konqueror/konqueror-16.12.0-r1.ebuild
new file mode 100644
index 00000000..3a49a33
--- /dev/null
+++ b/kde-apps/konqueror/konqueror-16.12.0-r1.ebuild
@@ -0,0 +1,109 @@
+# Copyright 1999-2017 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Id$
+
+EAPI=6
+
+KDE_HANDBOOK="forceoptional" # not optional until !kdelibs4support
+KDE_TEST="true"
+VIRTUALX_REQUIRED="test"
+inherit flag-o-matic kde5
+
+DESCRIPTION="Web browser and file manager based on KDE Frameworks"
+HOMEPAGE="
+       https://www.kde.org/applications/internet/konqueror/
+       https://konqueror.org/
+"
+KEYWORDS="~amd64 ~x86"
+IUSE="activities speech tidy X"
+# 4 of 4 tests fail. Last checked for 4.0.3
+RESTRICT+=" test"
+
+# drop qtwebengine subslot operator when QT_MINIMAL >= 5.8.0
+COMMON_DEPEND="
+       $(add_frameworks_dep karchive)
+       $(add_frameworks_dep kbookmarks)
+       $(add_frameworks_dep kcmutils)
+       $(add_frameworks_dep kcodecs)
+       $(add_frameworks_dep kcompletion)
+       $(add_frameworks_dep kconfig)
+       $(add_frameworks_dep kconfigwidgets)
+       $(add_frameworks_dep kcoreaddons)
+       $(add_frameworks_dep kcrash)
+       $(add_frameworks_dep kdbusaddons)
+       $(add_frameworks_dep kded)
+       $(add_frameworks_dep kdelibs4support)
+       $(add_frameworks_dep kdesu)
+       $(add_frameworks_dep kguiaddons)
+       $(add_frameworks_dep khtml)
+       $(add_frameworks_dep ki18n)
+       $(add_frameworks_dep kiconthemes)
+       $(add_frameworks_dep kio)
+       $(add_frameworks_dep kitemviews)
+       $(add_frameworks_dep kjobwidgets)
+       $(add_frameworks_dep kparts)
+       $(add_frameworks_dep kservice)
+       $(add_frameworks_dep kwidgetsaddons)
+       $(add_frameworks_dep kwindowsystem)
+       $(add_frameworks_dep kxmlgui)
+       $(add_qt_dep qtdbus)
+       $(add_qt_dep qtgui)
+       $(add_qt_dep qtwebengine 'widgets' '' '5=')
+       $(add_qt_dep qtwidgets)
+       $(add_qt_dep qtxml)
+       sys-libs/zlib
+       speech? ( $(add_qt_dep qtspeech) )
+       tidy? ( app-text/htmltidy )
+       X? ( $(add_qt_dep qtx11extras) )
+"
+DEPEND="${COMMON_DEPEND}
+       activities? ( $(add_frameworks_dep kactivities) )
+"
+RDEPEND="${COMMON_DEPEND}
+       $(add_kdeapps_dep kfind)
+       $(add_plasma_dep kde-cli-tools)
+       !kde-apps/kfmclient:4
+       !kde-apps/konq-plugins
+       !kde-apps/libkonq:5
+"
+
+PATCHES=( "${FILESDIR}/${PN}-16.12.0-crashfix.patch" )
+
+src_prepare() {
+       [[ ${CHOST} == *-solaris* ]] && append-ldflags -lmalloc
+
+       kde5_src_prepare
+}
+
+src_configure() {
+       local mycmakeargs=(
+               $(cmake-utils_use_find_package activities KF5Activities)
+               $(cmake-utils_use_find_package speech Qt5TextToSpeech)
+               $(cmake-utils_use_find_package tidy LibTidy)
+               $(cmake-utils_use_find_package X X11)
+       )
+       kde5_src_configure
+}
+
+pkg_postinst() {
+       kde5_pkg_postinst
+
+       if ! has_version kde-apps/keditbookmarks:${SLOT} ; then
+               elog "For bookmarks support, install keditbookmarks:"
+               elog "kde-apps/keditbookmarks:${SLOT}"
+       fi
+
+       if ! has_version kde-apps/dolphin:${SLOT} ; then
+               elog "If you want to use konqueror as a filemanager, install 
the dolphin kpart:"
+               elog "kde-apps/dolphin:${SLOT}"
+       fi
+
+       if ! has_version kde-apps/svg:${SLOT} ; then
+               elog "For konqueror to view SVGs, install the svg kpart:"
+               elog "kde-apps/svgpart:${SLOT}"
+       fi
+
+       if ! has_version virtual/jre ; then
+               elog "To use Java on webpages install virtual/jre."
+       fi
+}

Reply via email to